
#include <avr/io.h>

#include "display.h"
#include "ds1820.h"
#include "tsic.h"

#define	PWM_COUNT 10

#define BPIN1 1<<4
#define BPIN2 1<<5
#define BPIN3 1<<6
#define BUTTONPORT PIND
#define BUTTON1 BUTTONPORT&BPIN1
#define BUTTON2 BUTTONPORT&BPIN2
#define BUTTON3 BUTTONPORT&BPIN3

//#define TSICPIN 1<<1
//#define TSIC (PINA&TSICPIN)


int main(){

	Display lcd;

	DDRA = 0xff;
	PORTA = 0xff;
	DDRB = 0xff;
	PORTB = 0xff;
	
	
	DDRD = 0xff;
	PORTD = 0x00;
	
	DDRC = 0xff;
	PORTC = 0x00; 

	
	
	lcd.init();
	lcd.clear();
	
	// timer A
	//TCCR1A &= (0<<COM1A1);
	//TCCR1A &= (0<<COM1A0); // tollen ausgangspin nicht verwenden ...
	
	TCCR0 =(1<<WGM01) |(1<<CS01);
	OCR0=100;
		//Compare Interrupt aktivieren
		// TIMSK|=(1<<OCIE0);
		//Globale Interrupts aktivieren
		// sei();

		
	bool runok = true;

	
	// tsicpin
	DDRA = DDRA & 0b11111100;
	PORTA = 0x00;
	
	// Timer 1
	TCCR1B |= 1<<CS11; // vorteiler 8
	
	uint16_t time = 0;
	uint16_t timeOld = 0;
	
	
	// mit richtigem packet und nicht mittendrin starten -> von letzter fallender flanke, bis nchster -> zeitkontrolle
	uint8_t 	tStrobe = 0; // zwischen 60 und 65
	uint8_t		timeStartTSIC = 0;
	bool	startTSIC = false;
	bool	oldTSIC = true; // alter pegel
	bool	strobeRead = false;
	bool	readTSIC = false;
	uint8_t	ignoreNext = 0; // fr nchstes byte
	
	uint16_t timeOldTSIC = 0;
	uint8_t	byte1 = 0x00;
	uint8_t	byte2 = 0x00;
	uint8_t cbit = 0;
	uint8_t cbyte = 0;
	
	uint8_t dsStat = 0; // aus
	uint8_t		timeDs = 0;
	
	int timeMs = 0;
	int timeMsTemp = 0;
	
	timeStartTSIC = TCNT1L;
	timeStartTSIC |= TCNT1H<<8;
	
	TSIC tsic;
	tsic.m_pDisplay = &lcd;
	
	while( runok ){
	
		time = TCNT1L;
		time |= TCNT1H<<8;
		if( time - timeOld > 1000 ){
			timeOld = time;
			timeMs++;
			if( timeMs > 100000 ) timeMs = 0;
		}
		
		//AUFRUF MIT C++ (unten dann alles ausgeklammert):
		 // tsic.run(time);
	
		// start wenn lange pegel 1
		if( !startTSIC ){
			if( !TSIC ) 
				timeStartTSIC = time; // pegel 0? > neuanfang
			if( time - timeStartTSIC > 10000 ){
				startTSIC = true; // grer 2ms
				oldTSIC = true;
			}
		} 
		
		
		// TSIC, fallende Flanke aufnehmen
		if( oldTSIC && !TSIC ){
			timeOldTSIC = time;
			oldTSIC = false;
			
			// an der richtigen stelle anfangen
			if( startTSIC ){
			
				// Messung anfangen
				if( strobeRead ){
					if( ignoreNext == 1){ // zweites Startbit aussetzen
						 ignoreNext = 2; // STARTBIT MUSS AUSSETZEN -> steigende flanke mit abfangen (gesondert)
					} else readTSIC = true;
				}
			}
		}

		
		
		// steigende Flanke, funktionen (keine messung)
		if( startTSIC &&
			!readTSIC && TSIC && !oldTSIC ){	 
			oldTSIC = true; // fallende flanke vorbereiten
				
		
			// TSTROBE - nur eine messung bei steigender Flanke -> tStrobe ermitteln
			if( !strobeRead ){
				tStrobe = time-timeOldTSIC;
				if( tStrobe > 50 &&
					tStrobe < 75) // gegen ungltige
				 strobeRead = true;
				 
				 cbit = 0;
			}
			
			// 2tesBYTE - startbit vom zweiten byte aussetzen, fallende flanke passiert -> hier auf steigende warten
			if( ignoreNext == 2 ){
				ignoreNext = 0; // wieder normaler betrieb
			}
			
		}
		
		// messung starten, fallende Flanke grade passiert
		if( startTSIC &&
			readTSIC && cbyte < 2 ){
			// tStrobe abwarten und Wert ermitteln
			if( time-timeOldTSIC > tStrobe ){					
				
					if( cbit < 8 ){
						//TESTEN: if( TSIC ) byte1 |= 1<<(7-i)
						//uint8_t TSICval = TSIC;
						if( cbyte == 0 ){
							if( TSIC ) byte1 |= 1<<(7-cbit); // eigentlich richtig, geht aber nur mit umkehrung
						//	byte1 |= TSIC<<cbit; 
						} else 	{
							if( TSIC ) byte2 |= 1<<(7-cbit); // hier funktionierts einwandfrei ... hm.
						}
						 
						cbit++;
						
						oldTSIC = TSIC; //TODO: rausfinden, warum <<5 und <<6. hm :(
										//IDEE: steigende flanke direkt vor fallender -> falls timing problem
					}
					// cbyte1 == 8 -> parity 
					//nchstes byte: HIGH - START - weitere Bits
					if( cbit == 8){
						
						//Byte1 umkehren
						if( cbyte == 0 ){
							uint8_t b = 0x00;
							for( uint8_t c=0;c<8;c++ ){
								if( byte1 & 1<<c)
								 b |= 1<<(7-c);
							}
						//	byte1=b;
							byte1>>=1;
						}
						
						cbyte++;						
						cbit = 0;
						ignoreNext = 1;
				
					}
					
				// neue fallende Flanke abwarten 
				 //oldTSIC = TSIC; // NICHT!!! bringt fehler!
				 readTSIC = false;
			}
		}
		
		if(  cbyte > 1 //&&			timeMs - timeMsTemp > 1
			){
			timeMsTemp = timeMs;

					
			
			lcd.setCursor(0,0);
			sprintf( buffer, "%3i %3i %3i", tStrobe, byte1, byte2);
			//sprintf( buffer, "%2i-", byte2);
			
			lcd.write(buffer);
			
			
			
			lcd.setCursor(0,1);
			lcd.writeHex( byte1 );
			lcd.writeHex( byte2 );
			lcd.addChar(' ');
			
		
			lcd.writeFloat( (0.097704f*((byte1<<8)+byte2)) - 50.f, 2,2);
			
			
		}
		if( cbyte > 1 ){
			cbyte = 0;
			cbit = 0;
			readTSIC = false;
			strobeRead = false;
			startTSIC = false;
			byte1 = 0x00;
			byte2 = 0x00;
		}
	}
	
	
	return 0;
}
