// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  TSIC 
//   neuer Versuch
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

#include <avr/io.h>	
#include "tsic.h"
#include "display.h"



void	TSIC::run( uint16_t time ){
	// start wenn lange pegel 1
		if( !startTSIC ){
			if( !TSIC_PIN ) 
				timeStartTSIC = time; // pegel 0? > neuanfang
			if( time - timeStartTSIC > 10000 ){
				startTSIC = true; // grer 2ms
				oldTSIC = true;
			}
		} 
		
		
		// TSIC, fallende Flanke aufnehmen
		if( oldTSIC && !TSIC_PIN ){
			timeOldTSIC = time;
			oldTSIC = false;
			
			// an der richtigen stelle anfangen
			if( startTSIC ){
			
				// Messung anfangen
				if( strobeRead ){
					if( ignoreNext == 1){ // zweites Startbit aussetzen
						 ignoreNext = 2; // STARTBIT MUSS AUSSETZEN -> steigende flanke mit abfangen (gesondert)
					} else readTSIC = true;
				}
			}
		}

		
		
		// steigende Flanke, funktionen (keine messung)
		if( startTSIC &&
			!readTSIC && TSIC_PIN && !oldTSIC ){	 
			oldTSIC = true; // fallende flanke vorbereiten
				
		
			// TSTROBE - nur eine messung bei steigender Flanke -> tStrobe ermitteln
			if( !strobeRead ){
				tStrobe = time-timeOldTSIC;
				if( tStrobe > 50 &&
					tStrobe < 75) // gegen ungltige
				 strobeRead = true;
				 
				 cbit = 0;
			}
			
			// 2tesBYTE - startbit vom zweiten byte aussetzen, fallende flanke passiert -> hier auf steigende warten
			if( ignoreNext == 2 ){
				ignoreNext = 0; // wieder normaler betrieb
			}
			
		}
		
		// messung starten, fallende Flanke grade passiert
		if( startTSIC &&
			readTSIC && cbyte < 2 ){
			// tStrobe abwarten und Wert ermitteln
			if( time-timeOldTSIC > tStrobe ){					
				
					if( cbit < 8 ){
						//TESTEN: if( TSIC ) byte1 |= 1<<(7-i)
						//uint8_t TSICval = TSIC;
						if( cbyte == 0 ){
							if( TSIC_PIN ) byte1 |= 1<<(7-cbit); // eigentlich richtig, geht aber nur mit umkehrung
						//	byte1 |= TSIC<<cbit; 
						} else 	{
							if( TSIC_PIN ) byte2 |= 1<<(7-cbit); // hier funktionierts einwandfrei ... hm.
						}
						 
						cbit++;
						
						oldTSIC = TSIC_PIN; //TODO: rausfinden, warum <<5 und <<6. hm :(
										//IDEE: steigende flanke direkt vor fallender -> falls timing problem
					}
					// cbyte1 == 8 -> parity 
					//nchstes byte: HIGH - START - weitere Bits
					if( cbit == 8){
						
						//Byte1 umkehren
						if( cbyte == 0 ){
							uint8_t b = 0x00;
							for( uint8_t c=0;c<8;c++ ){
								if( byte1 & 1<<c)
								 b |= 1<<(7-c);
							}
						//	byte1=b;
							byte1>>=1;
						}
						
						cbyte++;						
						cbit = 0;
						ignoreNext = 1;
				
					}
					
				// neue fallende Flanke abwarten 
				 //oldTSIC = TSIC; // NICHT!!! bringt fehler!
				 readTSIC = false;
			}
		}
		
		if(  cbyte > 1 //&&			timeMs - timeMsTemp > 1
			){

					
			
			m_pDisplay->setCursor(0,0);
			sprintf( buffer, "%3i %3i %3i", tStrobe, byte1, byte2);
			//sprintf( buffer, "%2i-", byte2);
			
			m_pDisplay->write(buffer);
			
			
			
			m_pDisplay->setCursor(0,1);
			m_pDisplay->writeHex( byte1 );
			m_pDisplay->writeHex( byte2 );
			m_pDisplay->addChar(' ');
			
		
			m_pDisplay->writeFloat( (0.097704f*((byte1<<8)+byte2)) - 50.f, 2,2);
		}
		if( cbyte > 1 ){
			cbyte = 0;
			cbit = 0;
			readTSIC = false;
			strobeRead = false;
			startTSIC = false;
			byte1 = 0x00;
			byte2 = 0x00;
		}


}